﻿# Read aloud the selected text in the active tab

import os
import pickle
import sounddevice as sd
from time import sleep
from profiles.mygui import *
from profiles.myfunc import *


block_size = 1000
home_folder = os.getcwd()+'\\'
dic_folder = home_folder+'dic\\'
maxsel = 2048

Model = { 'Russian':'model.pt'}

if os.path.exists('slr.@'):
    f = open('slr.@', 'rb')
    try:
        d = pickle.load(f)
        lang = d['Combo0']['Item']
        speaker = d['Combo1']['Item']
        threads = d['Combo3']['Item'];
        threads = int(threads)
    except:
        sys.exit('Плохой файл: slr.@\nВы можете переписать его с помощью "Text to Speech.py"')
    f.close()
else:
    sys.exit('Файл не найден: slr.@\nВы можете создать его с помощью "Text to Speech.py"')

ind = WActive()

s = WSelText(ind)[:maxsel]
pos, dlina = WSel(ind)
if dlina > maxsel: WSel(ind,pos,maxsel)

if d['Notes1']['Agree'].strip():
    dic_ids = d['Notes1']['Agree'].split('|')
    for i in range(len(dic_ids)): dic_ids[i] = int(dic_ids[i])-1
    dic_list = FilesList(dic_folder,('.dic','.rex'))
    dic_names = []
    for i in dic_ids: dic_names.append(dic_list[i])
    s = ApplyDicsToString(s, dic_folder, dic_names)

a = TextToParagList(s)
a = ParagsLimitation(a, block_size)
a = ParagsUnion(a, block_size)
for i in range(len(a)): a[i] = AddSSML(a[i])

StatusMessage('Подождите минутку...')

import torch

put_accent = True
put_yo = True
device = torch.device('cpu')
torch.set_num_threads(threads)
local_file = Model[lang]

model = torch.package.PackageImporter(local_file).load_pickle("tts_models", "model")
model.to(device)

sample_rate = 8000  #8000 24000 48000

n = len(a)
Speak = True
for i in range(n):
    if not Speak: break
    StatusMessage('Подождите минутку...')
    audio = model.apply_tts(ssml_text=a[i], speaker=speaker, sample_rate=sample_rate,
                            put_accent=put_accent, put_yo=put_yo)
    duration = len(audio)/sample_rate
    StatusMessage('Вслух... СТОП: '+BreakKeyName())
    sd.play(audio, sample_rate)
    d = 0
    while d < duration:
        if Cancel():
            Speak = False
            sd.stop()
            StatusMessage('')
            break
        sleep(0.100)
        d += 0.100
sd.stop()
StatusMessage('')
